#include <windows.h>
#include <string.h>
#include "WinVer.h"

DWORD vver;
HICON hIcon;
HINSTANCE hInst;
HWND hWnd, hBut0, hBut1, hBut2, hWin0, hWin1;
int vwin = 0, scrx, scry, winx = 286, winy = 200; // szeroko, wysoko gwnego okna programu
char snam[] = "WinVer 1.03", scla[] = "WinVerClass", vnam[60] = "unknown version\nor detection failed", smsg[110];

/* Krok 4: procedura gwnego okna programu */
LONG FAR PASCAL WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
switch(Message)
 {
// Tworzenie zawartoci gwnego okna programu
 case WM_CREATE:
 hWin0 = CreateWindow("STATIC", "\n\nPress Check button\nto verify version\nof your Windows.", WS_CHILD | WS_VISIBLE | SS_CENTER, 100, 10, 170, 100, hwnd, 0, hInst, 0);
 SendMessage(hWin0, WM_SETFONT, GetStockObject(ANSI_VAR_FONT), 0);
 hWin1 = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | SS_ICON, 44, 40, 0, 0, hwnd, 0, hInst, 0);
 hIcon = LoadIcon(hInst, MAKEINTRESOURCE(ID_ICON)); // Wczytanie ikony programu
 SendMessage(hWin1, STM_SETICON, hIcon, 0); // Wywietlenie wczytanej ikony
 hBut0 = CreateWindow("BUTTON", "Check", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 32, 128, 60, 30, hwnd, ID_CHECK, hInst, 0);
 hBut1 = CreateWindow("BUTTON", "About", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 112, 128, 60, 30, hwnd, ID_ABOUT, hInst, 0);
 hBut2 = CreateWindow("BUTTON", "Quit", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 192, 128, 60, 30, hwnd, ID_QUIT, hInst, 0);
 break;

// Obsuga odbieranych rozkazw
 case WM_COMMAND:
 switch(wParam)
  {
// Wybranie przycisku "Check"
  case ID_CHECK:
  if(vwin) goto A;
// Rozpoznawanie wersji systemu Windows
  vver = GetVersion();
  vwin = HIBYTE(HIWORD(vver));
  switch(vwin)
   {
   case 6: // Windows 3.x
   sprintf(vnam, "3.1/3.11");
   hIcon = LoadIcon(hInst, MAKEINTRESOURCE(ID_WIN3X)); // Wczytanie ikony Windows 3.x
   break;
   case 7: // Windows 9x
   sprintf(vnam, "95/98");
   hIcon = LoadIcon(hInst, MAKEINTRESOURCE(ID_WIN9X)); // Wczytanie ikony Windows 9x
   break;
   case 8: // Windows ME
   sprintf(vnam, "ME");
   hIcon = LoadIcon(hInst, MAKEINTRESOURCE(ID_WINME)); // Wczytanie ikony Windows ME
   break;
   case 5: // Windows NT
   sprintf(vnam, "NT/2000/XP/2003/\nVista/2008/7/8/2012/10/\n2016/2019/2022/11");
   hIcon = LoadIcon(hInst, MAKEINTRESOURCE(ID_WINNT)); // Wczytanie ikony Windows NT
   break;
   }
  if(strlen(vnam)!=35)
   {SendMessage(hWin1, STM_SETICON, hIcon, 0); // Wywietlenie wczytanej ikony
    if(vwin!=5) sprintf(vnam, "%s\n(MS-DOS %u.%u)", vnam, vwin, LOBYTE(HIWORD(vver)));}
// Wywietlanie informacji o systemie
A:
  sprintf(smsg, "\nGetVersion() returned DWORD:\n%04X %04X\n\nWindows %s", HIWORD(vver), LOWORD(vver), vnam);
  SendMessage(hWin0, WM_SETTEXT, 0, (LONG)smsg); // Wywietlenie informacji o systemie
  vwin = 1;
  break;

// Wybranie przycisku "About"
  case ID_ABOUT:
  sprintf(smsg, "WinVer 1.03 for Win16\n\nReleased 08.06.2022\nby Roman Brenski\nusing Open Watcom 1.9.\n\nThis program is freeware.");
  SendMessage(hWin0, WM_SETTEXT, 0, (LONG)smsg); // Wywietlenie informacji o programie
  break;

// Wybranie przycisku "Quit"
  case ID_QUIT:
  SendMessage(hwnd, WM_DESTROY, 0, 0);
  break;
  }
 break;

// Aktywacja gwnego okna programu
 case WM_SETFOCUS:
 SendMessage(hBut1, BM_SETSTYLE, 0, 1); // Usunicie ramki z przycisku "About"
 SendMessage(hBut2, BM_SETSTYLE, 0, 1); // Usunicie ramki z przycisku "Quit"
 SendMessage(hBut0, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1); // Ustawienie ramki na przycisku "Check"
 SetFocus(hBut0); // Ustawienie fokusu na przycisku "Check"
 break;

// Niszczenie gwnego okna programu
 case WM_DESTROY:
 DestroyIcon(hIcon); // Niszczenie wczytanej ikony
 PostQuitMessage(0);
 break;

 default:
 return DefWindowProc(hwnd, Message, wParam, lParam);
 }
return 0;
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
MSG Msg;
WNDCLASS WndClass;
hInst = hInstance;
/* Krok 1: rejestrowanie klasy gwnego okna programu */
WndClass.style         = 0;
WndClass.lpfnWndProc   = WndProc;
WndClass.cbClsExtra    = 0;
WndClass.cbWndExtra    = 0;
WndClass.hInstance     = hInst;
WndClass.hCursor       = LoadCursor(0, IDC_ARROW);
WndClass.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(ID_ICON));
WndClass.hbrBackground = (HBRUSH)COLOR_BTNFACE;
WndClass.lpszMenuName  = 0;
WndClass.lpszClassName = scla;
if(!hPrevInstance)
 {if(!RegisterClass(&WndClass))
   {MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONSTOP);
    return 0;}}
// Centrowanie gwnego okna programu
scrx = GetSystemMetrics(SM_CXSCREEN); // Szeroko aktualnego ekranu
scry = GetSystemMetrics(SM_CYSCREEN); // Wysoko aktualnego ekranu
/* Krok 2: tworzenie gwnego okna programu */
hWnd = CreateWindow(scla, snam, WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX, (scrx-winx)/2, (scry-winy)/2, winx, winy, 0, 0, hInst, 0);
if(!hWnd)
 {MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONSTOP);
  return 0;}
ShowWindow(hWnd, nCmdShow);
UpdateWindow(hWnd);
/* Krok 3: ptla wiadomoci gwnego okna programu */
  while(GetMessage(&Msg, 0, 0, 0) > 0)
   {if(!IsDialogMessage(hWnd, &Msg))
     {TranslateMessage(&Msg);
      DispatchMessage(&Msg);}}
return Msg.wParam;
}
