#include <windows.h>
#include <string.h>
#include "WinVer.h"

#define SM_SERVERR2 89

typedef BOOL (WINAPI *LPVX64) (HANDLE, PBOOL);
BOOL vx64;
LPVX64 vadr;
BITMAP bmpi;
HDC hdc0, hdc1;
HINSTANCE hInst;
OSVERSIONINFOEX osv;
HBITMAP hBmp0, hBmp1;
DWORD pixt, vmaj, vmin, vbui;
HWND hWnd, hBut0, hBut1, hBut2, hWin0, hWin1;
int vwin = 0, vbit = 32, bmpx, bmpy, scrx, scry, winx = 286, winy = 200; // szeroko, wysoko gwnego okna programu
char snam[] = "WinVer 1.03", scla[] = "WinVerClass", vnam[20] = "unknown version", smsg[110];

/* Krok 4: procedura gwnego okna programu */
LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
switch(Message)
 {
// Tworzenie zawartoci gwnego okna programu
 case WM_CREATE:
 hWin0 = CreateWindow("STATIC", "\n\nPress Check button\nto verify version\nof your Windows.", WS_CHILD | WS_VISIBLE | SS_CENTER, 100, 10, 170, 100, hwnd, 0, hInst, 0);
 SendMessage(hWin0, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);
 hWin1 = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | SS_BITMAP, 30, 32, 0, 0, hwnd, 0, hInst, 0);
 hBmp0 = LoadBitmap(hInst, ID_WINBMP); // Wczytanie pocztkowej bitmapy
 hdc0 = CreateCompatibleDC(0);
 SelectObject(hdc0, hBmp0);
 SelectObject(hdc0, CreateSolidBrush(GetSysColor(COLOR_BTNFACE)));
 ExtFloodFill(hdc0, 0, 0, GetPixel(hdc0, 0, 0), FLOODFILLSURFACE); // Zmiana koloru ta w pocztkowej bitmapie na kolor ta gwnego okna programu
 DeleteDC(hdc0);
 SendMessage(hWin1, STM_SETIMAGE, 0, hBmp0); // Wywietlenie zmodyfikowanej pocztkowej bitmapy
 hBut0 = CreateWindow("BUTTON", "Check", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 30, 128, 60, 30, hwnd, ID_CHECK, hInst, 0);
 hBut1 = CreateWindow("BUTTON", "About", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 110, 128, 60, 30, hwnd, ID_ABOUT, hInst, 0);
 hBut2 = CreateWindow("BUTTON", "Quit", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON, 190, 128, 60, 30, hwnd, ID_QUIT, hInst, 0);
 break;

// Obsuga odbieranych rozkazw
 case WM_COMMAND:
 switch(LOWORD(wParam))
  {
// Wybranie przycisku "Check"
  case ID_CHECK:
  if(vwin) goto B;
// Rozpoznawanie wersji systemu Windows
  ZeroMemory(&osv, sizeof(OSVERSIONINFOEX));
  osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
  if(!GetVersionEx((OSVERSIONINFO *) &osv))
   {osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    if(!GetVersionEx((OSVERSIONINFO *) &osv)) // Nie rozpoznano wersji systemu Windows
     {sprintf(vnam, "detection failed");
      vmaj = _winmajor; // numer przed kropk
      vmin = _winminor; // numer za kropk
      vbui = _osver; // numer kompilacji
      goto A;}}
  vmaj = osv.dwMajorVersion; // numer przed kropk
  vmin = osv.dwMinorVersion; // numer za kropk
  vbui = osv.dwBuildNumber; // numer kompilacji
  switch(osv.dwPlatformId)
   {
// Windows 3.x
   case VER_PLATFORM_WIN32s:
   sprintf(vnam, "%u.%u", vmaj, vmin);
   vbui = LOWORD(osv.dwBuildNumber);
   vwin = 100;
   hBmp1 = LoadBitmap(hInst, ID_WIN3X); // Wczytanie bitmapy z symbolem Windows 3.x
   break;

// Windows 95, 98 lub ME
   case VER_PLATFORM_WIN32_WINDOWS:
   switch(vmin)
    {
    case 0:
    sprintf(vnam, "95");
    if(osv.szCSDVersion[1]==66) sprintf(vnam, "95 OSR 2");
    if(osv.szCSDVersion[1]==67) sprintf(vnam, "95 OSR 2.5");
    vwin = 200;
    hBmp1 = LoadBitmap(hInst, ID_WIN95); // Wczytanie bitmapy z symbolem Windows 95
    break;
    case 10:
    sprintf(vnam, "98");
    if(osv.szCSDVersion[1]==65) sprintf(vnam, "98 SE");
    vwin = 300;
    hBmp1 = LoadBitmap(hInst, ID_WIN98); // Wczytanie bitmapy z symbolem Windows 98
    break;
    case 90:
    sprintf(vnam, "ME");
    vwin = 400;
    hBmp1 = LoadBitmap(hInst, ID_WINME); // Wczytanie bitmapy z symbolem Windows ME
    break;
    }
   vbui = LOWORD(osv.dwBuildNumber);
   break;

// Windows z jdrem NT
   case VER_PLATFORM_WIN32_NT:
   if(vmaj<=4) // Windows NT 3.x/4.0
    {sprintf(vnam, "NT %u.%u", vmaj, vmin);
     vwin = 500;
     hBmp1 = LoadBitmap(hInst, ID_WINNT);} // Wczytanie bitmapy z symbolem Windows NT
   switch(vmaj)
    {
    case 5:
    switch(vmin)
     {
     case 0: // Windows 2000 (Pro/Server)
     if(osv.wProductType==VER_NT_WORKSTATION) sprintf(vnam, "2000 Pro");
     else sprintf(vnam, "2000 Server");
     vwin = 600;
     hBmp1 = LoadBitmap(hInst, ID_WIN2000); // Wczytanie bitmapy z symbolem Windows 2000
     break;
     case 1: // Windows XP (Home/Pro)
     if(osv.wSuiteMask==VER_SUITE_PERSONAL) sprintf(vnam, "XP Home");
     else sprintf(vnam, "XP Pro");
     vwin = 700;
     hBmp1 = LoadBitmap(hInst, ID_WINXP); // Wczytanie bitmapy z symbolem Windows XP
     break;
     case 2: // Windows XP Pro x64 lub 2003 Server (R2/Home)
     if(osv.wProductType==VER_NT_WORKSTATION)
      {sprintf(vnam, "XP Pro x64");
       vwin = 750;
       hBmp1 = LoadBitmap(hInst, ID_WINXP);} // Wczytanie bitmapy z symbolem Windows XP
     else
      {sprintf(vnam, "2003 Server");
       vwin = 800;
       if(GetSystemMetrics(SM_SERVERR2))
        {sprintf(vnam, "2003 Server R2");
         vwin = 850;}
       if(osv.wSuiteMask==VER_SUITE_WH_SERVER) sprintf(vnam, "2003 Server Home");
       hBmp1 = LoadBitmap(hInst, ID_WIN2003);} // Wczytanie bitmapy z symbolem Windows 2003 Server
     break;
     }
    break;
    case 6:
    switch(vmin)
     {
     case 0: // Windows Vista lub 2008 Server
     if(osv.wProductType==VER_NT_WORKSTATION)
      {sprintf(vnam, "Vista");
       vwin = 900;
       hBmp1 = LoadBitmap(hInst, ID_WINVISTA);} // Wczytanie bitmapy z symbolem Windows Vista
     else
      {sprintf(vnam, "2008 Server");
       vwin = 1000;
       hBmp1 = LoadBitmap(hInst, ID_WIN2008);} // Wczytanie bitmapy z symbolem Windows 2008 Server
     break;
     case 1: // Windows 7 lub 2008 Server R2
     if(osv.wProductType==VER_NT_WORKSTATION)
      {sprintf(vnam, "7");
       vwin = 1100;
       hBmp1 = LoadBitmap(hInst, ID_WIN7);} // Wczytanie bitmapy z symbolem Windows 7
     else
      {sprintf(vnam, "2008 Server R2");
       vwin = 1050;
       hBmp1 = LoadBitmap(hInst, ID_WIN2008);} // Wczytanie bitmapy z symbolem Windows 2008 Server
     break;
     case 2: // Windows 8 lub 2012 Server
     if(osv.wProductType==VER_NT_WORKSTATION)
      {sprintf(vnam, "8");
       vwin = 1200;
       hBmp1 = LoadBitmap(hInst, ID_WIN8);} // Wczytanie bitmapy z symbolem Windows 8
     else
      {sprintf(vnam, "2012 Server");
       vwin = 1300;
       hBmp1 = LoadBitmap(hInst, ID_WIN2012);} // Wczytanie bitmapy z symbolem Windows 2012 Server
     break;
     case 3: // Windows 8.1 lub 2012 Server R2
     if(osv.wProductType==VER_NT_WORKSTATION)
      {sprintf(vnam, "8.1");
       vwin = 1250;
       hBmp1 = LoadBitmap(hInst, ID_WIN8);} // Wczytanie bitmapy z symbolem Windows 8
     else
      {sprintf(vnam, "2012 Server R2");
       vwin = 1350;
       hBmp1 = LoadBitmap(hInst, ID_WIN2012);} // Wczytanie bitmapy z symbolem Windows 2012 Server
     break;
     }
    break;
    case 10: // Windows 10/11 lub 2016/2019/2022 Server
    if(osv.wProductType==VER_NT_WORKSTATION)
     {if(vbui<21327)
       {sprintf(vnam, "10");
        vwin = 1400;
        hBmp1 = LoadBitmap(hInst, ID_WIN10);} // Wczytanie bitmapy z symbolem Windows 10
      else
       {sprintf(vnam, "11");
        vwin = 1800;
        hBmp1 = LoadBitmap(hInst, ID_WIN11);}} // Wczytanie bitmapy z symbolem Windows 11
    else
     {if(vbui<17609)
       {sprintf(vnam, "2016 Server");
        vwin = 1500;
        hBmp1 = LoadBitmap(hInst, ID_WIN2016);} // Wczytanie bitmapy z symbolem Windows 2016 Server
      else
       {if(vbui<19504)
         {sprintf(vnam, "2019 Server");
          vwin = 1600;
          hBmp1 = LoadBitmap(hInst, ID_WIN2019);} // Wczytanie bitmapy z symbolem Windows 2019 Server
        else
         {sprintf(vnam, "2022 Server");
          vwin = 1700;
          hBmp1 = LoadBitmap(hInst, ID_WIN2022);}}} // Wczytanie bitmapy z symbolem Windows 2022 Server
    break;
    }
   break;
   }
// Rozpoznawanie wersji 32- lub 64-bitowej systemu
A:
  vadr = GetProcAddress(GetModuleHandle("kernel32"), "IsWow64Process");
  if(vadr)
   {if(vadr(GetCurrentProcess(),&vx64))
     {if(vx64) vbit = 64;}} // Wersja 64-bitowa systemu
  if(vwin) // Rozpoznano wersj systemu Windows
   {hdc0 = CreateCompatibleDC(0);
    SelectObject(hdc0, hBmp0);
    hdc1 = CreateCompatibleDC(0);
    SelectObject(hdc1, hBmp1);
    pixt = GetPixel(hdc1, 0, 0);
    GetObject(hBmp1, sizeof(bmpi), &bmpi);
// Nakadanie bitmapy z symbolem Windows na pocztkow bitmap
    for(bmpy=0; bmpy<bmpi.bmHeight; bmpy=bmpy+1)
     {for(bmpx=0; bmpx<bmpi.bmWidth; bmpx=bmpx+1)
       {if(pixt!=GetPixel(hdc1,bmpx,bmpy)) BitBlt(hdc0, bmpx, bmpy, 1, 1, hdc1, bmpx, bmpy, SRCCOPY);}}
    DeleteDC(hdc0);
    DeleteDC(hdc1);
    SendMessage(hWin1, STM_SETIMAGE, 0, hBmp0);} // Wywietlenie zmodyfikowanej pocztkowej bitmapy
// Wywietlanie informacji o systemie
B:
  sprintf(smsg, "\n\n\nWindows %s\n%u.%u.%u (%d-bit)", vnam, vmaj, vmin, vbui, vbit);
  SendMessage(hWin0, WM_SETTEXT, 0, smsg); // Wywietlenie informacji o systemie
  vwin = 1;
  break;

// Wybranie przycisku "About"
  case ID_ABOUT:
  sprintf(smsg, "WinVer 1.03 for Win32\n\nReleased 08.06.2022\nby Roman Brenski\nusing Open Watcom 1.9.\n\nThis program is freeware.");
  SendMessage(hWin0, WM_SETTEXT, 0, smsg); // Wywietlenie informacji o programie
  break;

// Wybranie przycisku "Quit"
  case ID_QUIT:
  SendMessage(hwnd, WM_DESTROY, 0, 0);
  break;
  }
 break;

// Aktywacja gwnego okna programu
 case WM_SETFOCUS:
 SendMessage(hBut1, BM_SETSTYLE, 0, 1); // Usunicie ramki z przycisku "About"
 SendMessage(hBut2, BM_SETSTYLE, 0, 1); // Usunicie ramki z przycisku "Quit"
 SendMessage(hBut0, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1); // Ustawienie ramki na przycisku "Check"
 SetFocus(hBut0); // Ustawienie fokusu na przycisku "Check"
 break;

// Niszczenie gwnego okna programu
 case WM_DESTROY:
 DeleteObject(hBmp0); // Usuwanie wczytanej bitmapy
 DeleteObject(hBmp1); // Usuwanie wczytanej bitmapy
 PostQuitMessage(0);
 break;

 default:
 return DefWindowProc(hwnd, Message, wParam, lParam);
 }
return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
MSG Msg;
WNDCLASSEX WndClass;
hInst = hInstance;
/* Krok 1: rejestrowanie klasy gwnego okna programu */
WndClass.cbSize        = sizeof(WNDCLASSEX);
WndClass.style         = 0;
WndClass.lpfnWndProc   = WndProc;
WndClass.cbClsExtra    = 0;
WndClass.cbWndExtra    = 0;
WndClass.hInstance     = hInst;
WndClass.hCursor       = LoadCursor(0, IDC_ARROW);
WndClass.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(ID_ICON));
WndClass.hIconSm       = LoadIcon(hInst, MAKEINTRESOURCE(ID_ICON));
WndClass.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
WndClass.lpszMenuName  = 0;
WndClass.lpszClassName = scla;
if(!RegisterClassEx(&WndClass))
 {MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONERROR);
  return 0;}
// Centrowanie gwnego okna programu
scrx = GetSystemMetrics(SM_CXSCREEN); // Szeroko aktualnego ekranu
scry = GetSystemMetrics(SM_CYSCREEN); // Wysoko aktualnego ekranu
/* Krok 2: tworzenie gwnego okna programu */
hWnd = CreateWindow(scla, snam, WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX, (scrx-winx)/2, (scry-winy)/2, winx, winy, 0, 0, hInst, 0);
if(!hWnd)
 {MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONERROR);
  return 0;}
ShowWindow(hWnd, nCmdShow);
UpdateWindow(hWnd);
/* Krok 3: ptla wiadomoci gwnego okna programu */
  while(GetMessage(&Msg, 0, 0, 0) > 0)
   {if(!IsDialogMessage(hWnd, &Msg))
     {TranslateMessage(&Msg);
      DispatchMessage(&Msg);}}
return Msg.wParam;
}
